; Calculation of pi:with DPMI (DOS PROTECTED MODE INTERFACE)
;
;                 1            1
; pi = 16 arc tg  +4 arc tg
;                 5           239
;
;formula Taylor:
;
;                  3     5     7     9
;                 x     x     x     x
; arc tg x = x -  +  -  +  - ...
;                 3     5     7     9
;----------------------------------------------------------------------------
.386
eloop	macro destination		;Macro for loop with ECX.
	db 67h				;Prefix for address.
	loop destination
	endm
;this eloop macro is necessary if ECX >= 2^16 ;digits > 631300 (=2^21 * log2)
struct_real_mode struc			;parameters in real mode.
reg_EDI  dd ?				;image registro EDI.
reg_ESI  dd ?				;image registro ESI.
reg_EBP  dd ?				;image registro EBP.
reserved dd ?
reg_EBX  dd ?				;image registro EBX.
reg_EDX  dd ?				;image registro EDX.
reg_ECX  dd ?				;image registro ECX.
reg_EAX  dd ?				;image registro EAX.
reg_Flags  dw ?				;image registro de indicadores.
reg_ES   dw ?				;image registro ES real mode.
reg_DS   dw ?				;image registro DS real mode.
reg_FS   dw ?				;image registro FS real mode.
reg_GS   dw ?				;image registro GS real mode.
reg_IP   dw ?				;image registro IP real mode.
reg_CS   dw ?				;image registro CS real mode.
reg_SP   dw ?				;image registro SP real mode.
reg_SS   dw ?				;image registro SS real mode.
struct_real_mode ends

HANDLE_STDOUT      equ 1		;Handle Standard Output (DOS).
HANDLE_STDERR      equ 2		;Handle Standard Error (DOS).

code  segment use16
	assume cs:code,ds:code
	org 100h			;Offset COM program
begin:jmp start				;jump to start of the program.

divisor		dd 1			;Divisor:  the values
					;1, 3, 5, 7,..from Taylor formulas.
digits		dd 0		        ;Amount of digits .

PMode_entry     label dword		;Address  protected mode.
PMode_entry_offs dw 0			;Offset.
PMode_entry_segm dw 0			;Segment.

quantdwords      dd 0			;DWords (32 bits) corresponding with
					;amount of digits .
firstdword       dd 0			;first dword next to zeros
					;or pointer to useless digits
HandleMemoryLow  dw 0			;Handle memory
HandleMemoryHigh dw 0			;server DPMI.
handle		dw	1		;Handle for pitxt file
Selector	dw	0
bufferdos	db	3 dup(55 dup(32),13,10),57 dup(32),4 dup(' '),2 dup('0'),13,10
point2pitxt	db	"c:\pidpm.txt",0
temp_buffer	db	200 dup(32)
contador	dw	0
	digi	dd	0
	ten	dd	10		;dd !
	m25	db	25
	count	dd	0
	hour	db	?
	min	db	?
	sec	db	?
	hund	db	?
	time	db	"CalculationTime 00:00:00.00",13,10,"$"
	bufdos	db	33h,2ch,13,10	;3 , cr lf

CopyRight db "Calcululation of PI.   Author: J.Kraak. DPMI by Dario Alpern."
db 13,10,"Purpose: Pi in 1000000 dec. with Machin's formula"
	db 13,10,"	Assembler:Masm 5.1"
	db 13,10,"	Output c:\pidpm.txt"
db 13,10,"The divisors arctan 1/5   :6003 12003 ....."
db 13,10,"The divisors arctan 1/239 :2001 4001 ....."
db 13,10,"and the amount of digits :5000 10000 ... display the progress. "
	db 13,10
LongitudCopyRight equ $ - CopyRight
text   db 13,10
	db "Usage of program: PIDPMC 10000 or more,maximum 4800000"
	db 13,10
Longitudtext equ $ - text
NoDPMI db "There is no DPMI server.Use windows 3.1 or 95",13,10
LongitudNoDPMI equ $ - NoDPMI
Server16Bits db "DPMI server does not support  32 bits applications"
	       db 13,10
LongitudServer16Bits equ $ - Server16Bits
NoMemoryForServer db "No local memory for  server DPMI."
	       db 13,10
LongitudNoMemoryForServer equ $ - NoMemoryForServer
NoProtectedMode db "No protected mode."
	       db 13,10
LongitudNoProtectedMode equ $ - NoProtectedMode
NoResverSelector db "No  reservation of a selector."
	       db 13,10
LongitudNoResverSelector equ $ - NoResverSelector
memory db 13,10
	db "There is no sufficient memory for so much decimals",13,10
Longitudmemory equ $ - memory
Realmode struct_real_mode <0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0>
;=============================================================================
start: mov dx,offset CopyRight		;Put on the screen  "copyright".
	mov cx,LongitudCopyRight
	mov bx,HANDLE_STDERR		;Handle STDERR.
	mov ah,40h
	int 21h
	mov	dx,offset point2pitxt	;handle for txt file
	mov	cx,0
	mov	ah,3ch
	int	21h			;DOS FUNCTION
	mov	handle,ax		;Save handle

;================================================================;
VerificationDPMI:
	mov Realmode.reg_DS,ds
	pushf
	pop ax
	and ax,0FFFh
	mov Realmode.reg_Flags,ax
	mov ax,1687h			;DPMI server installed in memory?
	int 2Fh
	test ax,ax
	jz short iniciateDPMI		;Jump if there is a DPMI server.
	mov dx,offset NoDPMI
	mov cx,LongitudNoDPMI		;Show that there is no DPMI server.
error_en_real:
	mov bx,HANDLE_STDERR		;Handle STDERR.
	mov ah,40h
	int 21h
	mov ax,4c01h			;End of the program, errorcode 1.
	int 21h
iniciateDPMI:
	mov PMode_entry_segm,es		;entry point server
	mov PMode_entry_offs,di		;for protected mode.
	test bl,1			;support of applications de 32bits?
	mov dx,offset Server16Bits
	mov cx,LongitudServer16Bits
	jz short error_en_real		;Jump  if no 32 bits.
	test si,si			;local memory necessary?
	jz short Go_to_protected_mode	;Jump if not necessary.
	push ds
	pop es				;ES = Segment Com program.
	push si				;bytes necessary for DPMI
	mov ah,4Ah			;minimum bloc of memory that
	mov bx,offset fin_code[15]	;includes the program .COM
	shr bx,4
	int 21h
	pop bx
	mov ah,48h
	int 21h				;Reserve memory for DPMI.
	mov cx,LongitudNoMemoryForServer
	mov dx,offset NoMemoryForServer
	jc short error_en_real		;Jump if not enough memory.
	mov es,ax			;Point to the data area DPMI.
Go_to_protected_mode:
	mov ax,1			;application is 32 bits.
	call PMode_entry		;Go to protected mode.
	mov cx,LongitudNoProtectedMode
	mov dx,offset NoProtectedMode
	jc short error_en_real
	push ds
	pop es				;Change ES = DS.
	xor ax,ax
	mov cx,1			;Reserve a descriptor.
	int 31h
	mov cx,LongitudNoResverSelector
	mov dx,offset NoResverSelector
	jc short error_protected_mode
	mov Selector,ax			;Make corresponding selector .
	mov bx,ax
	mov ax,0009h
	mov cx,40F2h
	int 31h				;Put the real byte of access.

AmountOfDecimals:

	mov bx,80h			;Point to the first byte in command line
	mov esi,10			;ESI = Mul 10
	xor eax,eax
	xor ecx,ecx			;Init. digits to zero.
BasketOfDigits:
	inc bx				;Point to the next byte.
	mov al,[bx]			;character of the line de comandos.
	cmp al,13			;End of the line?
	je short error			;Jump to error if there is no line.
	cmp al," "			;Space or character not to print?
	jbe BasketOfDigits		;Jump next character.
	sub al,"0"			;Character is between '0' and '9'.
	cmp al,9
	jbe short NumeroLineaDeComando	;Jump to commandline.
					;If there is no number go to error.
error:
	mov dx,offset text		;Display text
	mov cx,Longitudtext
error_protected_mode:
	mov bx,HANDLE_STDERR		;Handle STDERR.
	mov ah,40h
	call dos
	mov ax,4c01h			;End of the program with code error 1.
	int 21h
NewDigit:
	mul esi				;Mul 10.
	jc NotEnoughMemory		;Jump if the result is too big.
	add eax,ecx			;add
	jc NotEnoughMemory		;Jump if the result is too big.
NumeroLineaDeComando:
	inc bx				;Point to the next byte of the line.
	mov cl,[bx]			;Take the character
	sub cl,"0"			;Is it between 0 and 9 .
	cmp cl,9
	jbe	NewDigit		;Repeat.
	mov	digits,eax		;Store amount of digits in variable.
	mov	digi,eax		;Used in conversion
	add	eax,12			;12 extra
	mov	esi,445861642		;= 2^32/log(2^32)
	mul	esi
	mov	quantdwords,edx		;store DWords required.
	mov	firstdword,edx
	shl	edx,2			;Convert to bytes.
	lea	edx,[edx * 2 ]		;!  Reserve space for 2 buffers.
;The first buffer for adding and subtracting all the terms.
;The second buffer for storing and computing.
	or	dx,0FFFh		;Calculate the limit of page compl.
	shld	ecx,edx,16		;CX = High part of the limit.
	push	cx			;Save high part of the limit.
	push	dx			;Save low part of the limit.
	mov	bx,Selector
	mov	ax,0008h
	int	31h			;Install the limit of the segment.
	pop	cx			;Restore low part of the limit.
	pop	bx			;Restore high part of the limit.
	add cx,1			;You have to save one byte more
	adc bx,0                        ;than the limit.
	mov ax,0501h			;Reserve BX:CX bytes of memory linear.
	int 31h				;BX:CX = Direction linear bloc.
					;SI:DI = Handle memory.
	jnc short EntryOfDigits		;Jump if there are no errors.
NotEnoughMemory:
	mov dx,offset memory		;Indication error.
	mov cx,Longitudmemory
	mov ah,40h
	call dos
	mov ax,4C02h			;Exit.
	int 21h
EntryOfDigits:
	mov HandleMemoryLow,di		;Save handle memory location
	mov HandleMemoryHigh,si		;in SI:DI
	mov dx,cx			;DX = Low part of the segment base.
	mov cx,bx			;CX = High part of the segment base.
	mov ax,0007h
	mov bx,Selector
	int 31h				;Fill segment base.
;------------------------------------------------------------------------------

	mov	ah,9h			;get time
	mov	ah,2ch
	int	21h
	mov	min,cl			;save time
	mov	sec,dh
	mov	hund,dl
	mov	hour,ch
	mov	bufferdos[7],13		;cr
	mov	bufferdos[8],10		;lf
;-----------Start computation in extended memory.
	mov	ecx,firstdword		;firstdword = quantdwords only here.
	lea	edi,[ecx*4-4]		;point to the first buffer
	lea	esi,[edi+ecx*4]		;point to the second buffer
	mov	es,Selector		;Segment selector for extended memory.
	mov	ebx,5
	mov	edx,1
	std                     	;processor direction decrementing.
					;all computations from right to left
CicloCalcFirstTerm:
	xor	eax,eax			;the decimal part denominator is zero
	div	ebx			;Divide by 5	1/5
	mov	es:[esi],eax		;store 0.2 in the second buffer
	stos	dword ptr es:[edi]	;store 0.2 in the first buffer
	lea	esi,[esi-4]
	eloop CicloCalcFirstTerm	;Begin loop.
;--------------------------------------------------
; 0.2 dec.  stored as .......333333333333333333333333333333333333.0 hex.
;--------------------------------------------------
	mov	ecx,firstdword
	lea	edi,[ecx*4-4]
	lea	esi,[edi+ecx*4]
	mov	ebx,25			;Denominator.
	mov	edx,3			;3.2/25
CicloCalcSecondTerm:
	lods	dword ptr es:[esi]
	div	ebx
	mov	es:[esi+4],eax		;+4 !!!
	eloop	CicloCalcSecondTerm

	mov	divisor,3
	mov	ebx,3
	call	dpmidivsub
arctan1:
	add	divisor,2
	mov	eax,25
	mul    	divisor
	mov	ebx,eax
	call	dpmidivadd

	add	divisor,2
	mov	eax,625			;divisor*625 < 2^32
	mul	divisor
	mov	ebx,eax
	call	dpmidivsub
;---------------------------
;speed increases about 15% if dividing by divisor*625*25 and
;divisor*239^2 but output is then limited to about 178833 digits.
;---------------------------
	mov	ebx,625*25		;If divisor > 274877 then
	add	divisor,2               ;divisor*625*25 > 2^32 !!
	call	dpmidivdivadd		;This procedure divides first by
					;625*25 and then by the divisor
	add	divisor,2
	mov	eax,25
	mul    	divisor
	mov	ebx,eax
	call	dpmidivsub

	add	divisor,2
	mov	eax,625
	mul	divisor
	mov	ebx,eax
	call	dpmidivadd

	mov	ebx,625*25
	add	divisor,2
	call	dpmidivdivsub
;-----------
;log divisor + divisor*log5 = digits
;digits=1000000 is corresponding with divisor = 1430669
	add	contador,1
	cmp	contador,500
jne NoDisplayDivisorFirstArctan
	mov	contador,0
	mov	bx,6			;7 bytes
	mov	cx,7			; 7 digits
	mov	eax,divisor
DisplayDivisor:				;
	cmp	eax,0			;zeros on te left?
	je	@F
	xor	edx,edx
	div	ten			;long to decimal
	add	dl,30h			;to ascii
	mov	bufferdos[bx],dl	;store in bufferdos
	dec	bx
	loop	DisplayDivisor
@@:
	mov	bx,1			;@write	bufferdos,9,1
	mov	dx,offset bufferdos	;
	mov	cx,9			;7 + cr,lf
	mov	ah,40h			;
	call	dos
NoDisplayDivisorFirstArctan:
;------------
	mov	ecx,firstdword
	lea	edi,[ecx*4-4]		;point to the first buffer
	mov	eax,quantdwords
	lea	esi,[edi+eax*4]		;point to the second buffer
	cmp	dword ptr es:[esi],0	;dword zero ?
	jne	arctan1			;no? go on
	sub	firstdword,1		;all the dwords zero? start sec.arct
	jnz	arctan1

;-------------------------------------------------------------------------
secondarctan:
	mov	contador,0
	mov	bufferdos[3],32	;' '
	mov	bufferdos[2],32	;' '
	mov	bufferdos[1],32	;' '
	mov	bufferdos[0],32	;' '
	mov	ecx,quantdwords
	mov	firstdword,ecx
	lea	edi,[ecx*4-4]           ;point to the first buffer
	lea	esi,[edi+ecx*4]         ;point to the second buffer
	mov	ebx,239			;Denominator first term
	mov	edx,4			;4/239

CalcPrimerTermino:
	xor	eax,eax			;the decimal part denominator is zero
	div	ebx			;divide by 239
	mov	es:[esi],eax		;store 4/239 in the second buffer.
	lea	esi,[esi-4]
	eloop CalcPrimerTermino		;eloop
	mov	divisor,1
	mov	ebx,1			;divide by 1 and sub.
	call dpmidivsub
arctan2:
	add	divisor,2
	mov	ebx,239*239
	call	dpmidivdivadd		;term 2,4,6.....
	add	divisor,2
	call	dpmidivdivsub		;term 3,5,7.....
;-----------
;log divisor + divisor*log239 = digits
;digits=1000000 is corresponding with divisor = 420445
	add	contador,1
	cmp	contador,500
jne NoDisplayDivisorSecondArctan
	mov	contador,0
	mov	bx,6			;7 bytes
	mov	cx,7			;7 digits
	mov	eax,divisor
DisplayDivisor2:
	cmp	eax,0			;zeros on te left?
	je      exitonzero
	xor	edx,edx
	div	ten			;long to decimal
	add	dl,30h			;to ascii
	mov	bufferdos[bx],dl
	dec	bx
	loop	DisplayDivisor2
exitonzero:
	mov	bx,1			;@write	bufferdos,9,1
	mov	dx,offset bufferdos	;
	mov	cx,9			;7 +cr,lf
	mov	ah,40h			;
	call	dos
NoDisplayDivisorSecondArctan:
;------------
	mov	ecx,firstdword
	lea	edi,[ecx*4-4]		;point to the first buffer
	mov	eax,quantdwords
	lea	esi,[edi+eax*4]		;point to the second buffer
	cmp	dword ptr es:[esi],0	;dword zero?
	jne	arctan2			;no? go on
	sub	firstdword,1		;all the dwords zero? start conversion
	jnz	arctan2			;no? go on

	jmp	StartConversion


;-------------------------------------------------------------------------
;		FOUR PROCEDURES ARE DOING ALL VITAL COMPUTATIONS:
dpmidivdivadd	proc	near
	mov	ecx,firstdword
	lea	edi,[ecx*4-4]		;point to the first buffer
	mov	eax,quantdwords
	lea	esi,[edi+eax*4]		;point to the second buffer
	xor	edx,edx
	xor	ebp,ebp
divdivaddloop:
	lods	dword ptr es:[esi]
	xchg	edx,ebp
	div	ebx			;divide by 25^3 or 239^2
	mov	dword ptr es:[esi+4],eax;esi+4!
	xchg	ebp,edx
	div	divisor                 ;all registers used
	add	dword ptr es:[edi],eax	;adc puts the carry on the wrong
	jnc	short	@F		;side.
	add	dword ptr es:[edi+4],1
	jc	short	car4		;Very rare carry.
@@:	lea	edi,[edi-4]
	eloop	divdivaddloop
	ret
car4:   push	edi
c4:	add	edi,4
	add	dword ptr es:[edi+4],1
	jc	short	c4
	pop	edi
	jmp	short	@B
dpmidivdivadd	endp

dpmidivdivsub	proc	near		;two times divide one subtraction
	mov	ecx,firstdword
	lea	edi,[ecx*4-4]		;point to the first buffer
	mov	eax,quantdwords
	lea	esi,[edi+eax*4]		;point to the second buffer
	xor	edx,edx
	xor	ebp,ebp
divdivsubloop:
	lods	dword ptr es:[esi]
	xchg	edx,ebp			;save edx
	div	ebx			;divide by 25^3 or 239^2
	mov	dword ptr es:[esi+4],eax;store in second buffer
	xchg	ebp,edx
	div	divisor
	sub	dword ptr es:[edi],eax	;subtract dword store result in the
	jnc	short	@F		;first buffer
	sub	dword ptr es:[edi+4],1
	jc	short	car2		;Very rare carry
@@:	lea	edi,[edi-4]
	eloop	divdivsubloop
	ret
car2:   push	edi
c2:	add	edi,4
	sub	dword ptr es:[edi+4],1
	jc	short	c2
	pop	edi
	jmp	short	@B
dpmidivdivsub	endp


dpmidivsub	proc	near		;one divide and one subtraction
	mov	ecx,firstdword
	lea	edi,[ecx*4-4]		;point to the first buffer
	mov	eax,quantdwords
	lea	esi,[edi+eax*4]		;point to the second buffer
	xor	edx,edx
divsubloop:
	lods	dword ptr es:[esi]
	div	ebx			;divide by 25- or 625*divisor
	sub	es:[edi],eax
	jnc	short	@F
	sub	dword ptr es:[edi+4],1
	jc	short	car1	    	;Very rare carry
@@:     lea	edi,[edi-4]
	eloop	divsubloop
	ret
car1:   push	edi
c1:	add	edi,4
	sub	dword ptr es:[edi+4],1
	jc	short	c1
	pop	edi
	jmp	short	@B

dpmidivsub	endp


dpmidivadd	proc	near
	mov	ecx,firstdword
	lea	edi,[ecx*4-4]		;point to the first buffer
	mov	eax,quantdwords
	lea	esi,[edi+eax*4]		;point to the second buffer
	xor	edx,edx
divaddloop:
	lods	dword ptr es:[esi]
	div	ebx
	add	es:[edi],eax
	jnc	short	@F
	add	dword ptr es:[edi+4],1
	jc	short	car3            ;Very rare carry
@@:     lea	edi,[edi-4]
	eloop	divaddloop
	ret
car3:   push	edi			;pidpmc 900000 produces false
c3:	add	edi,4			;decimals after no. 823212
	add	dword ptr es:[edi+4],1	;when this sentence is corrupt.
	jc	short	c3		;Extremely rare carry.
	pop	edi
	jmp	short	@B
dpmidivadd	endp


;----------------------------------------------------------------------------

StartConversion:
	mov	bx,handle		;@write	bufdos,4,handle
	mov	dx,offset bufdos	;
	mov	cx,4			;3, cr lf
	mov	ah,40h			;
	call	dos

	call binair2decimal
	mov es,Selector			;close the selector of the
	mov bx,Selector			;DPMI server.
	mov ax,0001h
	int 31h
	mov si,HandleMemoryHigh		;Releases memory previously
	mov di,HandleMemoryLow		;allocated.
	mov ax,0502h
	int 31h
call	rtime
	mov ax,4c00h			;End of the program.Exit
	int 21h
;----------------------------------------------------------------------------
; Subr dos:Necessary for calling DOS in real mode.
;
dos:
	mov word ptr Realmode.reg_EAX,ax  ;registers of the
	mov word ptr Realmode.reg_EBX,bx  ;struct real mode.
	mov word ptr Realmode.reg_ECX,cx
	mov word ptr Realmode.reg_EDX,dx
	mov word ptr Realmode.reg_ESI,si
	mov word ptr Realmode.reg_EDI,di
	mov word ptr Realmode.reg_SS,0
	mov word ptr Realmode.reg_SP,0
	mov ax,0300h                      ;calls interruption in real mode.
	mov bx,0021h                      ;DOS = Interruption 21h.
	xor cx,cx                         ;Amount of bytes to the stack:
					  ;zero.
	mov di,offset Realmode            ;point to struct real mode
	movzx edi,di
	push ds
	pop es
	int 31h
	mov ah,byte ptr Realmode.reg_Flags
	sahf
	mov es,Selector
	mov ax,word ptr Realmode.reg_EAX
	mov bx,word ptr Realmode.reg_EBX
	mov cx,word ptr Realmode.reg_ECX
	mov dx,word ptr Realmode.reg_EDX
	mov si,word ptr Realmode.reg_ESI
	mov di,word ptr Realmode.reg_EDI
	ret
;----------------------------------------------------------------------------

binair2decimal	proc near
	mov	ebp,100000000		;10^8
	mov	ebx,50000000		;useless
	mov	divisor,0		;used as counter here
	cld
repeat:	mov	contador,7		;
	mov	m25,25			;counter for 8*25 decimals.
loop200:
	mov	edi,firstdword		;here used as pointer
	mov	ecx,quantdwords
inner_eloop:
	mov	eax,es:[edi]		;point to the first buffer there
	mul	ebp			;is Pi in hex
	add	eax,ebx
	adc	edx,0
	mov	ebx,edx
	stos	dword ptr es:[edi]
	eloop	inner_eloop
;store_temp.
	mov	cx,8			;8 digits
	mov	eax,ebx
	mov	bx,contador		;contador is a Spanish counter
temploop:
	xor	edx,edx
	div	ten			;long to decimal
	add	dl,30h                  ;to ascii
	mov	temp_buffer[bx],dl
	dec	bx			;next digit
	loop	temploop
	add	contador,8
;end store_temp
	sub	m25,1
	jnz	loop200
	sub	digi,200		;digits minus 200 stored in digi
	jb	terminate		;are there digits modulo 200 ?

	call	FormatBufferDos
	mov	bx,handle		;@write	bufferdos,236,handle
	mov	dx,offset bufferdos	;
	mov	cx,236			;236 bytes to c:\pidpm.txt
	mov	ah,40h			;
	call	dos
;	mov	bx,1			;write to the screen
 ;	mov	dx,offset bufferdos	;
  ;	mov	cx,236			;236 bytes to the screen
   ;	mov	ah,40h			;
    ;	call	dos
;---display counter 5000 10000....if writing to the screen counter not needed
	add	divisor,1
	cmp	divisor,25		;25*200
	jne	nodispl
	mov	divisor,0
	mov	bx,1			;@write	bufferdos,9,1
	mov	dx,offset bufferdos+227	;
	mov	cx,9			;7digits + cr,lf
	mov	ah,40h			;
	call	dos
;-----------------
nodispl:
	add	firstdword,80		;make firstbuffer 80 bytes shorter
	sub	quantdwords,20		;these bytes are no more relevant.
	jmp	repeat
terminate:
	xor	dx,dx
	mov	eax,digits
	mov	esi,200			;digits modulo 200
	div	esi
	mov	bx,dx			;remainder in dx,bx
putblancs:
	mov	temp_buffer[bx],' '	;wipe out perhaps false digits
	inc	bx			;next
	cmp	bx,200			;end of the temp_buffer?
	jnae	putblancs

	call	FormatBufferDos
	mov	bx,handle		;@write	bufferdos,226,handle
	mov	dx,offset bufferdos	;
	mov	cx,226			;226 ,wipe out last counter
	mov	ah,40h			;
	call	dos
	mov	bx,handle		;@write	bufdos,2,handle
	mov	dx,offset bufdos+2	;
	mov	cx,2			;cr,lf
	mov	ah,40h			;
	call	dos
	ret
binair2decimal	endp

FormatBufferDos	proc	near
	xor	di,di
	xor	si,si
xx5:	mov	bx,5                    ;format bufferdos
xx10:	mov	dx,10			;5 times 10 digits
next:	mov	al,temp_buffer[si]
	mov	bufferdos[di],al
	inc	di
	inc	si
	dec	dx
	jnz	next
	inc	di
	dec	bx
	jnz	xx10
	add	di,2
	cmp	si,200			;after 200 digits a counter.
	jne	xx5
	call	teller200		;teller = Dutch counter
	ret
FormatBufferDos	endp
teller200	proc	near
	add	count,2			;counter for 2,4,6..... *100
	mov	bx,231			;234-3
	mov	cx,5			; 7 digits (5 + 2 zeros)
	mov	eax,count
ddd:	cmp	eax,0			;no zeros on te left
	je	@F
	xor	edx,edx
	div	ten			;long to decimal
	add	dl,30h			;to ascii
	mov	bufferdos[bx],dl
	dec	bx
	loop	ddd

@@:	ret
teller200	endp
;---------------------------------------------------------------------------
rtime	proc	near
	mov	ah,2ch			;get time
	int	21h
	sub	dl,hund			; hund
	jnc	n1
	add	dl,100
n1:	sbb	dh,sec			; sec
	jnc	n2
	add	dh,60
n2:	sbb	cl,min			; min
	jnc	n3
	add	cl,60
n3:	sbb	ch,hour			; hour
	jnc	n4
	add	ch,24
n4:

	mov	bl,10
	mov	si,13
	mov	al,ch
	call	fill

	mov	al,cl
	call	fill
	mov	al,dh
	call	fill
	mov	al,dl
	call	fill
	mov	dx,offset time			;display time
	mov	ah,09h
	int	21h
	mov	bx,handle			;write time to pi.txt
	mov	dx,offset time
	mov	cx,29
	mov	ah,40h
	int	21h
	ret
rtime	endp
fill	proc	near
	add	si,3
	xor	ah,ah
	div	bl
	add	ax,3030h
	mov	byte ptr time[si],al
	mov	byte ptr time[si+1],ah
	ret
fill endp
;-----------------------------------------------------------------------------
fin_code:
code  ends
	end begin

;---------------------------------------------------------------------------

Questions or if you figure out a way to speed things up, that you please
let me know; my e-mail address is jkraak@compuserve.com
